local Cryolysis2 = Cryolysis2
local L = AceLibrary("AceLocale-2.2"):new("Cryolysis2")
local BS = AceLibrary("Babble-Spell-2.2")

------------------------------------------------------------------------------------------------------
-- Update properties of the Teleport/Portal button
------------------------------------------------------------------------------------------------------
function Cryolysis2:UpdateTeleAndPortButton()

-- Cryo2PortMenu0 inherits SecureStateHeaderTemplate
-- Cryo2TeleAndPortMenuButton inherits SecureAnchorButtonTemplate
-- Cryolysis2.Private.HasPortMenuTeleport tracks which teleport spells the user has

	Cryo2TeleAndPortMenuButton:SetAttribute("*childraise*", true)
	Cryo2TeleAndPortMenuButton:SetAttribute("*childstate*", "^click")
	Cryo2PortMenu0:SetAttribute("statemap-anchor-click", "0-1")
	Cryo2TeleAndPortMenuButton:SetAttribute("anchorchild", Cryo2PortMenu0)
	
	local lastPortAdded = 0
	for i = 1, #(Cryolysis2.Private.HasPortMenuTeleport), 1 do
		local CurrPortMenu = getglobal(Cryolysis2.Private.PortMenu[i])
		if Cryolysis2.Private.HasPortMenuTeleport[i] then   
			if lastPortAdded == 0 then
				CurrPortMenu:ClearAllPoints()
				if Cryolysis2.db.profile.PortMenuGrowLeft == true then
					CurrPortMenu:SetPoint("CENTER", "Cryo2TeleAndPortMenuButton", "CENTER", -33 + Cryolysis2.db.profile.PortMenuOfsX, Cryolysis2.db.profile.PortMenuOfsY)
				else
					CurrPortMenu:SetPoint("CENTER", "Cryo2TeleAndPortMenuButton", "CENTER", 33 + Cryolysis2.db.profile.PortMenuOfsX, Cryolysis2.db.profile.PortMenuOfsY)
				end
				CurrPortMenu:SetAttribute("showstates", "!0,*")
				Cryo2PortMenu0:SetAttribute("addchild", CurrPortMenu)
				lastPortAdded = i
			else
				CurrPortMenu:ClearAllPoints()
				if Cryolysis2.db.profile.PortMenuGrowLeft == true then
					CurrPortMenu:SetPoint("CENTER", "Cryo2PortMenu"..lastPortAdded, "CENTER", -33, 0)
				else
					CurrPortMenu:SetPoint("CENTER", "Cryo2PortMenu"..lastPortAdded, "CENTER", 33, 0)
				end
				CurrPortMenu:SetAttribute("showstates", "!0,*")
				Cryo2PortMenu0:SetAttribute("addchild", CurrPortMenu)
				lastPortAdded = i
			end
		end
	end
end

------------------------------------------------------------------------------------------------------
-- Update attributes of the Teleport/Portal sub-buttons
------------------------------------------------------------------------------------------------------
function Cryolysis2:UpdatePortMenuAttributes()
	
	if Cryolysis2.Private.englishFaction == "Alliance" then
		if Cryolysis2.Private.HasPortMenuTeleport[1] then
			Cryo2PortMenu1Icon:SetTexture("Interface\\Icons\\Spell_Arcane_TeleportIronForge")
			Cryo2PortMenu1:SetAttribute("type1", "spell")
			Cryo2PortMenu1:SetAttribute("spell1", BS["Teleport: Ironforge"])
			if Cryolysis2.Private.HasPortMenuPort[1] then
				Cryo2PortMenu1:SetAttribute("type2", "spell")
				Cryo2PortMenu1:SetAttribute("spell2", BS["Portal: Ironforge"])
			end
		end
		if Cryolysis2.Private.HasPortMenuTeleport[2] then
			Cryo2PortMenu2Icon:SetTexture("Interface\\Icons\\Spell_Arcane_TeleportStormWind")
			Cryo2PortMenu2:SetAttribute("type1", "spell")
			Cryo2PortMenu2:SetAttribute("spell1", BS["Teleport: Stormwind"])
			if Cryolysis2.Private.HasPortMenuPort[2] then
				Cryo2PortMenu2:SetAttribute("type2", "spell")
				Cryo2PortMenu2:SetAttribute("spell2", BS["Portal: Stormwind"])
			end
		end
		if Cryolysis2.Private.HasPortMenuTeleport[3] then
			Cryo2PortMenu3Icon:SetTexture("Interface\\Icons\\Spell_Arcane_TeleportDarnassus")
			Cryo2PortMenu3:SetAttribute("type1", "spell")
			Cryo2PortMenu3:SetAttribute("spell1", BS["Teleport: Darnassus"])
			if Cryolysis2.Private.HasPortMenuPort[3] then
				Cryo2PortMenu3:SetAttribute("type2", "spell")
				Cryo2PortMenu3:SetAttribute("spell2", BS["Portal: Darnassus"])
			end
		end
		if Cryolysis2.Private.HasPortMenuTeleport[4] then
			Cryo2PortMenu4Icon:SetTexture("Interface\\Icons\\Spell_Arcane_TeleportExodar")
			Cryo2PortMenu4:SetAttribute("type1", "spell")
			Cryo2PortMenu4:SetAttribute("spell1", BS["Teleport: Exodar"])
			if Cryolysis2.Private.HasPortMenuPort[4] then
				Cryo2PortMenu4:SetAttribute("type2", "spell")
				Cryo2PortMenu4:SetAttribute("spell2", BS["Portal: Exodar"])
			end
		end
	end
	if Cryolysis2.Private.englishFaction == "Horde" then
		if Cryolysis2.Private.HasPortMenuTeleport[1] then
			Cryo2PortMenu1Icon:SetTexture("Interface\\Icons\\Spell_Arcane_TeleportOrgrimmar")
			Cryo2PortMenu1:SetAttribute("type1", "spell")
			Cryo2PortMenu1:SetAttribute("spell1", BS["Teleport: Orgrimmar"])
			if Cryolysis2.Private.HasPortMenuPort[1] then
				Cryo2PortMenu1:SetAttribute("type2", "spell")
				Cryo2PortMenu1:SetAttribute("spell2", BS["Portal: Orgrimmar"])
			end
		end
		if Cryolysis2.Private.HasPortMenuTeleport[2] then
			Cryo2PortMenu2Icon:SetTexture("Interface\\Icons\\Spell_Arcane_TeleportUnderCity")
			Cryo2PortMenu2:SetAttribute("type1", "spell")
			Cryo2PortMenu2:SetAttribute("spell1", BS["Teleport: Undercity"])
			if Cryolysis2.Private.HasPortMenuPort[2] then
				Cryo2PortMenu2:SetAttribute("type2", "spell")
				Cryo2PortMenu2:SetAttribute("spell2", BS["Portal: Undercity"])
			end
		end
		if Cryolysis2.Private.HasPortMenuTeleport[3] then
			Cryo2PortMenu3Icon:SetTexture("Interface\\Icons\\Spell_Arcane_TeleportThunderBluff")
			Cryo2PortMenu3:SetAttribute("type1", "spell")
			Cryo2PortMenu3:SetAttribute("spell1", BS["Teleport: Thunder Bluff"])
			if Cryolysis2.Private.HasPortMenuPort[3] then
				Cryo2PortMenu3:SetAttribute("type2", "spell")
				Cryo2PortMenu3:SetAttribute("spell2", BS["Portal: Thunder Bluff"])
			end
		end
		if Cryolysis2.Private.HasPortMenuTeleport[4] then
			Cryo2PortMenu4Icon:SetTexture("Interface\\Icons\\Spell_Arcane_TeleportSilvermoon")
			Cryo2PortMenu4:SetAttribute("type1", "spell")
			Cryo2PortMenu4:SetAttribute("spell1", BS["Teleport: Silvermoon"])
			if Cryolysis2.Private.HasPortMenuPort[4] then
				Cryo2PortMenu4:SetAttribute("type2", "spell")
				Cryo2PortMenu4:SetAttribute("spell2", BS["Portal: Silvermoon"])
			end
		end
	end
	
	-- Both factions get this one!
	if Cryolysis2.Private.HasPortMenuTeleport[5] then
		Cryo2PortMenu5Icon:SetTexture("Interface\\Icons\\Spell_Arcane_TeleportShattrath")
		Cryo2PortMenu5:SetAttribute("type1", "spell")
		Cryo2PortMenu5:SetAttribute("spell1", BS["Teleport: Shattrath"])
		if Cryolysis2.Private.HasPortMenuPort[5] then
			Cryo2PortMenu5:SetAttribute("type2", "spell")
			Cryo2PortMenu5:SetAttribute("spell2", BS["Portal: Shattrath"])
		end
	end
end
